﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = PopulateGrid;
    }

    public DataTable PopulateGrid
    {
        get
        {
            DataTable data = default(DataTable);

            if (Session["GridData"] == null)
            {
                data = GenerateData();

                Session["GridData"] = data;
            }

            data = (DataTable)Session["GridData"];

            return data;
        }

        set { Session["GridData"] = value; }
    }

    public DataTable GenerateData()
    {
        DataTable data = new DataTable();

        data.Columns.Add("ID", typeof(int));
        data.Columns.Add("Name");
        data.Columns.Add("Description");

        for (int i = 1; i <= 30; i++)
        {
            data.Rows.Add(i, "Name" + (i % 5).ToString(), "Description" + i.ToString());
        }

        return data;
    }

    protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
    {
        GridBatchEditingEventArgument argument = e.CommandArgument as GridBatchEditingEventArgument;

        GridEditableItem editItem = e.Item as GridEditableItem;

        DataTable newData = PopulateGrid;

        DataRow[] row = newData.Select("ID = " + editItem.OwnerTableView.DataKeyValues[editItem.ItemIndex]["ID"].ToString());

        row[0]["Name"] = argument.NewValues["Name"];
        row[0]["Description"] = argument.NewValues["Description"];

        newData.AcceptChanges();

    }

    protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
    {
        GridBatchEditingEventArgument argument = e.CommandArgument as GridBatchEditingEventArgument;

        DataTable newData = PopulateGrid;

        DataRow row = newData.NewRow();

        row["ID"] = argument.NewValues["ID"];
        row["Name"] = argument.NewValues["Name"];
        row["Description"] = argument.NewValues["Description"];

        newData.Rows.Add(row);

    }
}